/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Emma connectivity Prague
* Date First Issued  : 12/xx/2007
* Description        : Main program body
********************************************************************************
* History:
* mm/dd/yyyy: V0.1
* 12/00/2007: V0.01
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

#include "led_dimmer.h"
#include "stm32f10x_lib.h"
#include "table_generator.h"

#include "led_demonstration.h"
#include "board_control.h"

#include "hw_config.h"
#include "serial.h"

extern u8 usb_plugged;

extern struct buttonsAndADC buttonsADC;
unsigned char *LookUp;

unsigned char LEDmapClear[48] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,

                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

unsigned char LEDmapTMP[48];

int tableSize;
unsigned char aaa;
unsigned char *tablePtr, *tableKeyPtr;
unsigned char modeSelector;

//demonstration
struct environment env;
struct buttonsAndADC buttons;
signed int userData[12];
//end of demonstration

int X;
u8 receivedCharacterUSB;

void waitAbit(int a){
  unsigned int i, y;
  for(i=0; i<600; i++)  
    for(y=0; y<a; y++)
      X = a+i+y;
}

int main(void){
#ifdef DEBUG
  debug();
#endif

  RCC_Configuration();

  // VCOM
   /* Enable GPIOB for USB pullup (reset) */
   RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

   /* Set USB clock */

   /* USBCLK = PLLCLK/1.5 */
   RCC_USBCLKConfig(RCC_USBCLKSource_PLLCLK_Div1);

   /* Enable USB clock */
   RCC_APB1PeriphClockCmd(RCC_APB1Periph_USB, ENABLE);    
//   RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);    
  
  NVIC_Configuration();
  SPI_DMA_Init();

  fillDriver(48, 2);
  GPIO_ResetBits(GPIOA, GPIO_Pin_4); //FAST_LE_LOW();
  GPIO_SetBits(GPIOA, GPIO_Pin_4);  //FAST_LE_HIGH();
  LED_driver_OutEnable_All_On();

  emberSerialInit();  //USB detection and enumeration

  if(usb_plugged)
    fillDriver(48, 4);
  else
    fillDriver(48, 3);
  GPIO_ResetBits(GPIOA, GPIO_Pin_4); //FAST_LE_LOW();
  GPIO_SetBits(GPIOA, GPIO_Pin_4);  //FAST_LE_HIGH();
  waitAbit(2000);
  fillDriver(48, 0);
  
  setup(48, PWM_8_bit, 100);

  if(!generateReducedLookUpTable(LEDmapClear, 48, PWM_8_bit, &tablePtr, &tableKeyPtr, &tableSize))
    while(1);
  use_new_table_immediately(tablePtr, tableKeyPtr, tableSize);

  start_dimmer();
 
  BC_GPIO_Configuration();
  BC_EXTI_Configuration();
  BC_NVIC_Configuration();  
  BC_ADC_Configuration();

  LED_driver_OutEnable_All_On();
  
  #define modes 4;
  modeSelector = 100;
  userData[1] = modes;
  env.columns = 3;
  env.rows = 5;
  env.setupGame = 1;      
  
  if(usb_plugged) emberSerialPrintf(APP_SERIAL, "*************************\r\n");
  if(usb_plugged) emberSerialPrintf(APP_SERIAL, "***** Demokit alive *****\r\n");
  
  while(1){

    switch(modeSelector){

    case   0: tetris_color(LEDmapClear, &buttonsADC, &env, &(userData[0]));break;            //A - tetris
    case   1: wave_color_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));break;                //B - WAVE demo
    case   2: solid_color_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));break;               //C - solid color demo
    case   3: error_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));                    //D - error detection
              if(env.gameFinished){
                error_detection_DMX(LEDmapClear, 48);
//                error_detection_LE_OE(LEDmapClear, 48);
                start_dimmer();
                LED_driver_OutEnable_All_On();
              }
              break;                                                                         
    case   4: error_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));                    //E - error detection
              if(env.gameFinished){
//                error_detection_DMX(LEDmapClear, 48);
                error_detection_LE_OE(LEDmapClear, 48);
                start_dimmer();
                LED_driver_OutEnable_All_On();
              }
              break;
    case   5: rolling_text(LEDmapClear, &buttonsADC, &env, &(userData[0]));                       //F
              break;
    case   6: rolling_text1(LEDmapClear, &buttonsADC, &env, &(userData[0]));                       //F
              break;
              
    case 100: modeSelect(LEDmapClear, &buttonsADC, &env, &(userData[0]));
              if(env.gameFinished){
                env.setupGame = 1;
                env.gameFinished = 0;
                modeSelector = userData[0];
                break;
                }
    default:modeSelector = 100;break;
    }

    if(env.refreshRequest){
      if(!generateReducedLookUpTable(LEDmapClear, 48, PWM_8_bit, &tablePtr, &tableKeyPtr, &tableSize))
        while(1);
      use_new_table_carefully(tablePtr, tableKeyPtr, tableSize);
      while(new_table_not_changed_yet());
      removeLookUpTableReleased();
      env.refreshRequest = 0;
    }
    if(usb_plugged) 
      if(!emberSerialReadByte(APP_SERIAL, &receivedCharacterUSB)){
        switch(receivedCharacterUSB){
        case 'd': buttonsADC.buttonRight = 1; break;
        case 'a': buttonsADC.buttonLeft = 1; break;
        case 's': buttonsADC.buttonCenter = 1; break;
        case 'q': modeSelector = 100; userData[1] = modes; env.setupGame = 1; env.gameFinished = 0;break;
        case '?': emberSerialPrintf(APP_SERIAL, "LED\r\n"); break;
        case 'T': error_detection_LE_OE(LEDmapTMP, 48);
                  start_dimmer();
                  LED_driver_OutEnable_All_On();
                  sendErrorsOverUSB(LEDmapTMP, 48);
                  break;
        }
        if(receivedCharacterUSB == 'd') emberSerialPrintf(APP_SERIAL, "***** Demokit received a character 'd' *****\r\n");
        if(receivedCharacterUSB == 'a') emberSerialPrintf(APP_SERIAL, "***** Demokit received a character 'a' *****\r\n");
        if(receivedCharacterUSB == 's') emberSerialPrintf(APP_SERIAL, "***** Demokit received a character 's' *****\r\n");
        if(receivedCharacterUSB == 'q') emberSerialPrintf(APP_SERIAL, "***** Demokit received a character 'q' *****\r\n");
      }
  }  
}//main
