/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : usb_endp.c
* Author             : MCD Application Team
* Date First Issued  : 05/21/2007
* Description        : Endpoint routines
********************************************************************************
* History:
* 05/21/2007: V0.3
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "usb_lib.h"
#include "usb_desc.h"
#include "usb_mem.h"
#include "hw_config.h"
#include "usb_istr.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
extern u8 buffer_out_empty;
extern u8 buffer_index;

u8 buffer_out[VIRTUAL_COM_PORT_DATA_SIZE];
u8 buffer_in[VIRTUAL_COM_PORT_DATA_SIZE];
u32 count_out =0;
u32 count_in = 0;


void buffer_out_error (void )

{
 // dummy function to move in a correct place SS ???
 
}

/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/*******************************************************************************
* Function Name  : EP3_IN_Callback
* Description    :
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP3_OUT_Callback(void)
{
  if (!buffer_out_empty)   // not all the bytes in buffer_out has been processed
    buffer_out_error();      

  count_out= GetEPRxCount(ENDP3);
  buffer_index = 0;
  buffer_out_empty = 0;
  PMAToUserBufferCopy(buffer_out, ENDP3_RXADDR, count_out);
  
  // the endpoint is enabled for reception, the check on the buffer_out bytes processing
  // is at the start of this function, but it should better to enable endpoint reception
  // in a different place SS ???
  SetEPRxValid(ENDP3);
}

/*******************************************************************************
* Function Name  : EP1_IN_Callback
* Description    :
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP1_IN_Callback(void)
{
  count_in = 0;
}

/******************* (C) COPYRIGHT 2007 STMicroelectronics *****END OF FILE****/

