/**
  ******************************************************************************
  * @file CLK_ClockSelection\stm8s_it.h
  * @brief This file contains the external declarations of the interrupt routines.
  * @author STMicroelectronics - MCD Application Team
  * @version V1.0.0
  * @date 18-JUL-2008
  ******************************************************************************
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  * 
  * <h2><center>&copy; COPYRIGHT 2008 STMicroelectronics</center></h2>
  * @image html logo.bmp
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __STM8S_IT_H
#define __STM8S_IT_H

/* Includes ------------------------------------------------------------------*/
#include "stm8s_lib.h"

/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */

void NonHandledInterrupt(void);
void EEPROM_EEC_IRQHandler(void); /* EEPROM ECC CORRECTION */
void TIM4_UPD_OVF_IRQHandler(void); /* TIM4 UPD/OVF */
void ADC_IRQHandler(void); /* ADC */
void UART1_RX_IRQHandler(void); /* UART1 RX */
void UART1_TX_IRQHandler(void); /* UART1 TX */
void I2C_IRQHandler(void); /* I2C */
void UART2_RX_IRQHandler(void); /* UART2 RX */
void UART2_TX_IRQHandler(void); /* UART2 TX */
void TIM3_CAP_COM_IRQHandler(void); /* TIM3 CAP/COM */
void TIM3_UPD_OVF_BRK_IRQHandler(void); /* TIM3 UPD/OVF/BRK */
void TIM2_CAP_COM_IRQHandler(void); /* TIM2 CAP/COM */
void TIM2_UPD_OVF_BRK_IRQHandler(void); /* TIM2 UPD/OVF/BRK */
void TIM1_CAP_COM_IRQHandler(void); /* TIM1 CAP/COM */
void TIM1_UPD_OVF_TRG_BRK_IRQHandler(void); /* TIM1 UPD/OVF/TRG/BRK */
void SPI_IRQHandler(void); /* SPI */
void CAN_TX_IRQHandler(void); /* CAN TX/SCE */
void CAN_RX_IRQHandler(void); /* CAN RX */
void EXTI_PORTE_IRQHandler(void); /* EXTI PORTE */
void EXTI_PORTD_IRQHandler(void); /* EXTI PORTD */
void EXTI_PORTC_IRQHandler(void); /* EXTI PORTC */
void EXTI_PORTB_IRQHandler(void); /* EXTI PORTB */
void EXTI_PORTA_IRQHandler(void); /* EXTI PORTA */
void CLK_IRQHandler(void); /* CLOCK */
void AWU_IRQHandler(void); /* AWU */
void TLI_IRQHandler(void); /* TLI */
void TRAP_IRQHandler(void); /* TRAP */
void _stext(void); /* RESET startup routine */

#endif /* __STM8S_IT_H */

/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/
