/**
  ******************************************************************************
  * @file TIM1_6Steps\stm8s_it.c
  * @brief This file contains all the interrupt routines.
  * @author STMicroelectronics - MCD Application Team
  * @version V1.0.0
  * @date 18-JUL-2008
  ******************************************************************************
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2008 STMicroelectronics</center></h2>
  * @image html logo.bmp
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "stm8s_it.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
u8 TimeCounter = 0;
u8 step = 1;
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/* Public functions ----------------------------------------------------------*/

/** @addtogroup TIM1_6Steps_IT_Functions
  * @{
  */

/**
  * @brief Dummy interrupt routine
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
*/
@near @interrupt void NonHandledInterrupt(void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief TRAP interrupt routine
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
*/
@near @interrupt void TRAP_IRQHandler(void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Top Level Interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TLI_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Auto Wake Up interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void AWU_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Clock Controller interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void CLK_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief External Interrupt PORTA routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void EXTI_PORTA_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief External Interrupt PORTB routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void EXTI_PORTB_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief External Interrupt PORTC routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void EXTI_PORTC_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief External Interrupt PORTD routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void EXTI_PORTD_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief External Interrupt PORTE routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void EXTI_PORTE_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief CAN RX interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void CAN_RX_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief CAN TX interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void CAN_TX_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief SPI interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void SPI_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Timer1 Update/Overflow/Trigger/Break interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TIM1_UPD_OVF_TRG_BRK_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Timer1 Capture/Compare interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TIM1_CAP_COM_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  
   /* Clear TIM1 COM pending bit */
  TIM1_ClearITPendingBit(TIM1_IT_COM);

  if(step == 1)
  {
    /* Next step: Step 2 Configuration ---------------------------- */	
    /*  Channel3 configuration */
	TIM1_CCxCmd(TIM1_CHANNEL_3, DISABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_3, DISABLE);

	/*  Channel1 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_1, TIM1_FORCEDACTION_ACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_1, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_1, ENABLE);
    
	/*  Channel2 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_2, TIM1_FORCEDACTION_INACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_2, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_2, ENABLE);	
    step++;
  }
  else if(step == 2)
  {
    /* Next step: Step 3 Configuration ---------------------------- */
    /*  Channel2 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_2, TIM1_FORCEDACTION_INACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_2, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_2, ENABLE);

	/*  Channel3 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_3, TIM1_FORCEDACTION_ACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_3, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_3, ENABLE);
    
	/*  Channel1 configuration */
	TIM1_CCxCmd(TIM1_CHANNEL_1, DISABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_1, DISABLE); 
    step++;
  }
  else if(step == 3)
  {
    /* Next step: Step 4 Configuration ---------------------------- */
    /*  Channel3 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_3, TIM1_FORCEDACTION_ACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_3, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_3, ENABLE);

	/*  Channel2 configuration */
	TIM1_CCxCmd(TIM1_CHANNEL_2, DISABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_2, DISABLE);
    
	/*  Channel1 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_1, TIM1_FORCEDACTION_INACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_1, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_1, ENABLE);
    step++;
  }
  else if(step == 4)
  {
    /* Next step: Step 5 Configuration ---------------------------- */
	/*  Channel3 configuration */
	TIM1_CCxCmd(TIM1_CHANNEL_3, DISABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_3, DISABLE);
	
	/*  Channel1 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_1, TIM1_FORCEDACTION_INACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_1, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_1, ENABLE);

	/*  Channel2 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_2, TIM1_FORCEDACTION_ACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_2, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_2, ENABLE);    
    step++;
  }
  else if (step == 5)
  {
    /* Next step: Step 6 Configuration ---------------------------- */
	/*  Channel3 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_3, TIM1_FORCEDACTION_INACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_3, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_3, ENABLE);

	/*  Channel1 configuration */
	TIM1_CCxCmd(TIM1_CHANNEL_1, DISABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_1, DISABLE);
    
	/*  Channel2 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_2, TIM1_FORCEDACTION_ACTIVE);
  	TIM1_CCxCmd(TIM1_CHANNEL_2, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_2, ENABLE);
    step++;
  }
  else
  {
    /* Next step: Step 1 Configuration ---------------------------- */
    /*  Channel1 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_1, TIM1_FORCEDACTION_ACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_1, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_1, ENABLE);
    
	/*  Channel3 configuration */
	TIM1_SelectOCxM(TIM1_CHANNEL_3, TIM1_FORCEDACTION_INACTIVE);
	TIM1_CCxCmd(TIM1_CHANNEL_3, ENABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_3, ENABLE);

	/*  Channel2 configuration */
	TIM1_CCxCmd(TIM1_CHANNEL_2, DISABLE);
	TIM1_CCxNCmd(TIM1_CHANNEL_2, DISABLE);
    step = 1;
  }	
  
  return;
}

/**
  * @brief Timer2 Update/Overflow/Break interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TIM2_UPD_OVF_BRK_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Timer2 Capture/Compare interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TIM2_CAP_COM_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Timer3 Update/Overflow/Break interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TIM3_UPD_OVF_BRK_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Timer3 Capture/Compare interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void TIM3_CAP_COM_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief UART2 TX interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void UART2_TX_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief UART2 RX interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void UART2_RX_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief I2C interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void I2C_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief UART1 TX interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void UART1_TX_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief UART1 RX interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void UART1_RX_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief ADC interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void ADC_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @brief Timer4 Update/Overflow interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * TIM1_GenerateEvent
  */
@near @interrupt void TIM4_UPD_OVF_IRQHandler (void)
{

	TIM4_ClearITPendingBit(TIM4_IT_UPDATE);
  
  if (TimeCounter == 11)
  {
		/* Generate TIM1 COM event by software */
		TIM1_GenerateEvent(TIM1_EVENTSOURCE_COM);
		TimeCounter=1;
	/*
		the TIM4 Update Interrupt occurs each 0.064ms ( Tui=(Period * Prescaler)/Fmaster  = (256*128)/2Mhz = 16,384 ms )
		so after 11 TIM4 Update Interrupts,  180ms have been spent  (T= 11 * 16,384  = 180.2 ms)
	*/

  }
  else
  {
		TimeCounter++;
  }
  return;
}

/**
  * @brief Eeprom EEC interrupt routine.
  * @par Parameters:
  * None
  * @retval void None
  * @par Required preconditions:
  * None
  * @par Called functions:
  * None
  */
@near @interrupt void EEPROM_EEC_IRQHandler (void)
{
  /* In order to detect unexpected events during development,
     it is recommended to set a breakpoint on the following instruction.
  */
  return;
}

/**
  * @}
  */

/******************* (C) COPYRIGHT 2008 STMicroelectronics *****END OF FILE****/
