/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Emma connectivity Prague
* Date First Issued  : 12/xx/2007
* Description        : Main program body
********************************************************************************
* History:
* mm/dd/yyyy: V0.1
* 12/00/2007: V0.01
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/
#include "stm8s_lib.h"
#include "board_control.h"

struct buttonsAndADC buttonsADC;

unsigned char functionButtonKnob(void){
  unsigned short a;
  /*Start Conversion */
  ADC_StartConversion();
	while (ADC_GetFlagStatus(ADC_FLAG_EOC) == SET);
  a = (ADC_GetConversionValue() >> 2);
  return (unsigned char)a;
}

void BC_ADC_Configuration(void)
{
  /*  Init GPIO for ADC */
  GPIO_Init(ADC_Port, ADC_Pin, GPIO_MODE_IN_FL_NO_IT);
  ADC_DeInit();
  /* Init ADC peripheral */
  ADC_Init(ADC_CONVERSIONMODE_SINGLE, ADC_CHANNEL_9, ADC_PRESSEL_FCPU_D2, ADC_EXTTRIG_GPIO, DISABLE, ADC_ALIGN_RIGHT, ADC_SCHMITTTRIG_CHANNEL9, DISABLE);
  ADC_Cmd(ENABLE);
  buttonsADC.buttonKnob = functionButtonKnob;
}

void BC_GPIO_Configuration(void)
{
  /* Initialize I/O in Input Mode with Interrupt */
  GPIO_Init(ButtonLeftRight_Port, (ButtonLeft_Pin | ButtonRight_Pin), GPIO_MODE_IN_FL_IT);
  
	GPIO_Init(ButtonSelect_Port, ButtonSelect_Pin, GPIO_MODE_IN_FL_IT);
  //GPIO_WriteHigh(ButtonSelect_Port, ButtonSelect_Pin);
}

void BC_EXTI_Configuration(void)
{
  disableInterrupts();
  //EXTI_DeInit();
  EXTI_SetExtIntSensitivity(EXTI_PORT_ButtonLeftRight, EXTI_SENSITIVITY_FALL_ONLY);
  EXTI_SetExtIntSensitivity(EXTI_PORT_ButtonSelect, EXTI_SENSITIVITY_FALL_ONLY);
  EXTI_SetTLISensitivity(EXTI_SENSITIVITY_FALL_ONLY);
  enableInterrupts();
}

