/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Emma connectivity Prague
* Date First Issued  : 12/xx/2007
* Description        : Main program body
********************************************************************************
* History:
* mm/dd/yyyy: V0.1
* 12/00/2007: V0.01
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/
const unsigned char sinuslog[101] = {67,74,81,89,97,105,114,123,133,142,152,161,171,181,190,199,208,216,223,230,235,240,244,247,249,249,
                                 249,247,244,240,235,230,223,216,208,199,190,181,171,162,152,142,133,123,114,106,97,89,81,74,67,61,55,
                                  49,44,39,34,30,27,23,20,17,15,12,10,8,7,5,4,3,2,1,1,0,0,0,0,0,1,1,2,3,4,5,7,8,10,12,14,17,20,23,26,
                                  30,34,39,43,49,54,60,67};

#include "led_demonstration.h"
#define minimalBrightness 1

int i;
static signed short t1, t2;
static signed short tmpenv;
//const unsigned char RTtext[18] = {'A','L','E','S','I','S','T','H','E','B','E','S','T',94,'I','E',93,92,};

signed int BC(signed int position, signed char color);

void modeSelect(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData){
#define MSE_select 0
#define MSE_maxim 1
#define MSE_highInk 2
#define MSE_i 5
#define MSE_y 6
#define MSE_flashing 7

  if(env->setupGame){                 //SETUP PART
    env->setupGame = 0;               //SETUP PART
    env->gameFinished = 0;
    btnADC->buttonCenter  = 0;        //SETUP PART
    userData[MSE_select] = 0;
    userData[MSE_flashing] = 0;    
  }                                   //SETUP PART

  userData[MSE_flashing]++;
  if(userData[MSE_flashing]>100)
     userData[MSE_flashing] = 0;

  if(btnADC->buttonCenter){ btnADC->buttonCenter = 0; env->gameFinished = 1;}
  if(btnADC->buttonRight)  { btnADC->buttonRight = 0; userData[MSE_select]++; if(userData[MSE_select] >= userData[MSE_maxim]) userData[MSE_select] = 0                  ;}
  if(btnADC->buttonLeft) {    btnADC->buttonLeft = 0; userData[MSE_select]--; if(userData[MSE_select] < 0)                   userData[MSE_select] = userData[MSE_maxim]-1;}

  for(userData[MSE_i] = 0; userData[MSE_i] < env->rows; userData[MSE_i]++)
    for(userData[MSE_y] = 0; userData[MSE_y] < env->columns; userData[MSE_y]++){
      tmpenv = env->columns * userData[MSE_i] + userData[MSE_y];
      LEDmap[BC(tmpenv, BLUE)]  = 0x00;
      LEDmap[BC(tmpenv, RED)]   = 0x00;
      LEDmap[BC(tmpenv, GREEN)] = 0x00;
    }
          
  userData[MSE_highInk] = btnADC->buttonKnob();
  writeCharacter(LEDmap, (unsigned char *) character_mask[userData[MSE_select]], ((userData[MSE_highInk])*(sinuslog[userData[MSE_flashing]]))/255, 0, ((255-userData[MSE_highInk])*(sinuslog[userData[MSE_flashing]]))/255, DONOTROTATE);
  env->refreshRequest = 1;
}

/*
void rolling_text(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData){
#define RT_select 0
#define RT_maxim 1
#define RT_highInk 2
#define RT_i 5
#define RT_y 6
#define RT_flashing 7
#define RT_textmaxindex 8

  if(env->setupGame){                 //SETUP PART
    env->setupGame = 0;               //SETUP PART
    env->gameFinished = 0;
    btnADC->buttonCenter  = 0;        //SETUP PART
    userData[RT_select] = 0;
    userData[RT_flashing] = 0;    
    userData[RT_textmaxindex] = 17; //+19
  }                                   //SETUP PART

  userData[RT_flashing]++;
  if(userData[RT_flashing]>100){
     userData[RT_flashing] = 0;
  }
  if(userData[RT_flashing]==73){
     userData[RT_select]++;
     if(userData[RT_select] > userData[RT_textmaxindex])
       userData[RT_select] = 0;
  }

  for(userData[RT_i] = 0; userData[RT_i] < env->rows; userData[RT_i]++)
    for(userData[RT_y] = 0; userData[RT_y] < env->columns; userData[RT_y]++){
      LEDmap[BC(env->columns * userData[RT_i] + userData[RT_y], BLUE)] =  0x00;
      LEDmap[BC(env->columns * userData[RT_i] + userData[RT_y], RED)] =   0x00;
      LEDmap[BC(env->columns * userData[RT_i] + userData[RT_y], GREEN)] = 0x00;
    }
          
  userData[RT_highInk] = btnADC->buttonKnob();
  writeCharacter(LEDmap, (unsigned char *) character_mask[RTtext[userData[RT_select]]-65], ((userData[RT_highInk])*(sinuslog[userData[RT_flashing]]))/255, 0, ((255-userData[RT_highInk])*(sinuslog[userData[RT_flashing]]))/255, DONOTROTATE);
  env->refreshRequest = 1;
}
*/

//---------------------------------------------------------- wavedemo  ------------------------------------------
void wave_color_demo(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData){
#define WDC_counter 0
#define WDC_position 1
#define WDC_row 2
#define WDC_column 3
#define WDC_next 4
#define WDC_recount 5
#define WDC_step 6
#define WDC_speed 7
#define WDC_subdemo 8
#define WDC_tmp 9
#define WDC_efect 10
#define shiftA 7
#define shiftB 14    

  if(env->setupGame){                 //SETUP PART
      for(userData[WDC_row] = 0; userData[WDC_row] < env->rows; userData[WDC_row]++)
        for(userData[WDC_column] = 0; userData[WDC_column] < env->columns; userData[WDC_column]++){
          tmpenv = env->columns * userData[WDC_row] + userData[WDC_column];
          LEDmap[BC(tmpenv, BLUE)] =  0x00;
          LEDmap[BC(tmpenv, RED)] =   0x00;
          LEDmap[BC(tmpenv, GREEN)] = 0x00;
      }   
    userData[WDC_counter] = 0;
    userData[WDC_position] = 0;
    userData[WDC_row] = 0;
    userData[WDC_column] = 0;
    userData[WDC_subdemo] = 0;
    userData[WDC_efect] = 0;
    env->gameFinished = 0;
    env->setupGame = 0;               //SETUP PART
  }                                   //SETUP PART
  
    if(btnADC->buttonCenter){
      userData[WDC_subdemo] ++;
      if(userData[WDC_subdemo] > 3){
        userData[WDC_subdemo] = 0;
      }
      btnADC->buttonCenter = 0;
    }     
     
    userData[WDC_step] = 20;//14

    userData[WDC_position]++;
    if(userData[WDC_position]>100) userData[WDC_position] = 0;

    for(userData[WDC_next] = 0; userData[WDC_next] < 5; userData[WDC_next]++){     
      userData[WDC_recount] = userData[WDC_position] + userData[WDC_next]*userData[WDC_step];
      if(userData[WDC_recount] > 100)
        userData[WDC_recount] = userData[WDC_recount] - 100;
			tmpenv = (env->columns * (userData[WDC_row]+userData[WDC_next]));
      switch(userData[WDC_subdemo]){
			case 0:
        t1 = userData[WDC_recount]+shiftA; t2 = userData[WDC_recount]+shiftB;
        if(t1 > 100) t1 = t1 - 100;	if(t2 > 100) t2 = t2 - 100;
        LEDmap[BC(tmpenv + 0, RED)]	= sinuslog[userData[WDC_recount]];
				LEDmap[BC(tmpenv + 1, RED )] = sinuslog[t1];
        LEDmap[BC(tmpenv + 2, RED )] = sinuslog[t2];
        userData[WDC_tmp] = userData[WDC_recount]+33;
        t1 = userData[WDC_tmp]+shiftA; t2 = userData[WDC_tmp]+shiftB;
        if(userData[WDC_tmp]>100) userData[WDC_tmp]=userData[WDC_tmp]-100;
        if(t1 > 100) t1 = t1 - 100; if(t2 > 100) t2 = t2 - 100;
        LEDmap[BC(tmpenv + 0, GREEN)] = sinuslog[userData[WDC_tmp]];
        LEDmap[BC(tmpenv + 1, GREEN)] = sinuslog[t1];
        LEDmap[BC(tmpenv + 2, GREEN)] = sinuslog[t2];
        userData[WDC_tmp] = userData[WDC_recount]+66;
        t1 = userData[WDC_tmp]+shiftA; t2 = userData[WDC_tmp]+shiftB;   
        if(userData[WDC_tmp]>100) userData[WDC_tmp]=userData[WDC_tmp]-100;
        if(t1 > 100) t1 = t1 - 100; if(t2 > 100) t2 = t2 - 100;
        LEDmap[BC(tmpenv + 0, BLUE )] = sinuslog[userData[WDC_tmp]];
        LEDmap[BC(tmpenv + 1, BLUE )] = sinuslog[t1];
        LEDmap[BC(tmpenv + 2, BLUE )] = sinuslog[t2];
        break;
      case 1:
        LEDmap[BC(tmpenv + 0, GREEN )] =
        LEDmap[BC(tmpenv + 1, BLUE  )] = 
        LEDmap[BC(tmpenv + 2, RED   )] = (255-sinuslog[userData[WDC_recount]]);
        LEDmap[BC(tmpenv + 0, RED   )] = 
        LEDmap[BC(tmpenv + 0, BLUE  )] = 
        LEDmap[BC(tmpenv + 1, RED   )] = 
        LEDmap[BC(tmpenv + 1, GREEN )] = 
        LEDmap[BC(tmpenv + 2, GREEN )] = 
        LEDmap[BC(tmpenv + 2, BLUE  )] = (sinuslog[userData[WDC_recount]]);
        break;
			case 2:
        LEDmap[BC(tmpenv + 0, RED  )] = 
        LEDmap[BC(tmpenv + 1, GREEN)] = 
        LEDmap[BC(tmpenv + 2, BLUE )] = sinuslog[userData[WDC_recount]];
        LEDmap[BC(tmpenv + 0, GREEN )] = 
        LEDmap[BC(tmpenv + 0, BLUE  )] = 
        LEDmap[BC(tmpenv + 1, BLUE  )] = 
        LEDmap[BC(tmpenv + 1, RED   )] = 
        LEDmap[BC(tmpenv + 2, GREEN )] = 
        LEDmap[BC(tmpenv + 2, RED   )] = 0;
        break;
      case 3:
        LEDmap[BC(tmpenv + 0, RED  )] = 
        LEDmap[BC(tmpenv + 0, GREEN  )] = 
        LEDmap[BC(tmpenv + 1, GREEN)] = 
        LEDmap[BC(tmpenv + 1, BLUE)] = 
        LEDmap[BC(tmpenv + 2, RED )] = 
        LEDmap[BC(tmpenv + 2, BLUE )] = sinuslog[userData[WDC_recount]];
        LEDmap[BC(tmpenv + 0, BLUE  )] = 
				LEDmap[BC(tmpenv + 1, RED )] = 
				LEDmap[BC(tmpenv + 2, GREEN)] = 0;
        break;
        default:;break;
			}			
    }
    env->refreshRequest = 1;
}
//====================================================================================================================

//signed int BCcorrectMapping(signed int position, signed char color){
signed int BC(signed int position, signed char color){
  switch(color)
  {
  case RED:
    switch(position){
    case -1:;                                                                       return (position +  1);
    case  0:; case  1:; case  2:; case  3:; case  4:; case  5:; case  6:            return (position +  1);
    case  7:; case  8:; case  9:; case 10:; case 11:; case 12:; case 13:; case 14:  return (position + 17);
    default: return 0;
    }
  case GREEN:
    switch(position){
    case -1:;                                                                       return (position +  9);
    case  0:; case  1:; case  2:; case  3:; case  4:; case  5:; case  6:            return (position +  9);
    case  7:; case  8:; case  9:; case 10:; case 11:; case 12:; case 13:; case 14:  return (position + 25);
    default: return 0;
    }
  case BLUE:
    switch(position){
    case -1:;                                                                       return (position + 17);
    case  0:; case  1:; case  2:; case  3:; case  4:; case  5:; case  6:;           return (position + 17);
    case  7:; case  8:; case  9:; case 10:; case 11:; case 12:; case 13:; case 14:  return (position + 33);
    default: return 0;
    }
  }
  return 0;
}

void tetris_color(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData){
#define TBW_counter 0
#define TBW_position_column 1
#define TBW_position_row 2
#define TBW_speed 3
#define TBW_cubecolor 4

#define TBW_i 5
#define TBW_y 6
#define TBW_ii 7
#define TBW_yy 8
#define TBW_level 9
#define TBW_rnd 10
int n100, n10, n1;
  
  env->refreshRequest = 0;

  //------------------- game finished ---------------------------
  if(env->gameFinished){              
    userData[TBW_counter]++;
//    if(userData[TBW_counter] > 200000){
    if(userData[TBW_counter] > 20000){
    userData[TBW_counter] = 0;
    userData[TBW_ii]++;
      if(userData[TBW_ii] > 8)
        userData[TBW_ii] = 0;
      n100 = (signed int) ((400 - userData[9]) / 100); 
      n10 =  (signed int)(((400 - userData[9]) - n100*100) / 10); 
      n1 =   (signed int) ((400 - userData[9]) - n100*100 - n10*10); 
      
      for(userData[TBW_i] = 0; userData[TBW_i] < env->rows; userData[TBW_i]++)
        for(userData[TBW_y] = 0; userData[TBW_y] < env->columns; userData[TBW_y]++){
          tmpenv = env->columns * userData[TBW_i] + userData[TBW_y];
					LEDmap[BC(tmpenv, BLUE)] =  0x00;
          LEDmap[BC(tmpenv, RED)] =   0x00;
          LEDmap[BC(tmpenv, GREEN)] = 0x00;
      }                           

      userData[TBW_cubecolor] = btnADC->buttonKnob();
      if(userData[TBW_cubecolor] < minimalBrightness) userData[TBW_cubecolor] = minimalBrightness;
      switch(userData[TBW_ii]){
      case 0: break;
      case 1: writeCharacter(LEDmap, (unsigned char *) number_mask[n100], 0, userData[TBW_cubecolor], 0, ROTATE);break;
      case 2: break;
      case 3: writeCharacter(LEDmap, (unsigned char *) number_mask[n10], 0, userData[TBW_cubecolor], 0, ROTATE);break;
      case 4: break;
      case 5: writeCharacter(LEDmap, (unsigned char *) number_mask[n1], 0, userData[TBW_cubecolor], 0, ROTATE);break;
      case 6: break;
      case 7: break;
      case 8: break;
      }
      env->refreshRequest = 1;
    }
    if(btnADC->buttonCenter){
      btnADC->buttonCenter  = 0;
      env->setupGame = 1;
      env->gameFinished = 0;
    }
    return;
  }
  //-------------------- game setup --------------------------
  if(env->setupGame){               
    userData[TBW_level] = 400;      
    userData[TBW_position_column] = 0;      
    userData[TBW_position_row] = 0;      
    userData[TBW_ii] = 0;
    env->setupGame = 0; 
    env->gameFinished = 0;
    for(userData[TBW_i] = 0; userData[TBW_i] < env->rows; userData[TBW_i]++)
      for(userData[TBW_y] = 0; userData[TBW_y] < env->columns; userData[TBW_y]++){
        tmpenv = env->columns * userData[TBW_i] + userData[TBW_y];
				LEDmap[BC(tmpenv, BLUE)] =  0;
        LEDmap[BC(tmpenv, RED)] =   0;
        LEDmap[BC(tmpenv, GREEN)] = 0;
      }    
    userData[TBW_cubecolor] = 0x0F;
    userData[TBW_rnd] = 0;
    env->refreshRequest = 1;
    btnADC->buttonCenter  = 0;
    return;
  }        
  //----------------------------------------------
  
  if(userData[TBW_counter] > 2000){
    LEDmap[BC(env->columns * userData[TBW_position_row] + userData[TBW_position_column], GREEN)] = 0x00;  //clear old cube

    userData[TBW_counter] = 0;
    userData[TBW_cubecolor] = btnADC->buttonKnob();
    if(userData[TBW_cubecolor] < 5) userData[TBW_cubecolor] = 5;
    
    if(btnADC->buttonRight){
      userData[TBW_rnd]++;
      btnADC->buttonRight  = 0;
      if(userData[TBW_position_column] > 0)
        if(LEDmap[BC(env->columns * (userData[TBW_position_row]) + userData[TBW_position_column]-1, BLUE)] == 0)
          userData[TBW_position_column] -= 1;
    }
    if(btnADC->buttonLeft){
      userData[TBW_rnd]++;
      btnADC->buttonLeft = 0;
      if(userData[TBW_position_column] < (env->columns-1))
        if(LEDmap[BC(env->columns * (userData[TBW_position_row]) + userData[TBW_position_column]+1, BLUE)] == 0)
          userData[TBW_position_column] += 1;
    }

    userData[TBW_speed]++;
    if(userData[TBW_speed] > (userData[TBW_level]>>4))
    {
      userData[TBW_speed] = 0;
      if(userData[TBW_position_row] == (env->rows-1))
      {
        LEDmap[BC(env->columns * userData[TBW_position_row] + userData[TBW_position_column], BLUE)] = userData[TBW_cubecolor];
        userData[TBW_position_row] = 0;
        userData[TBW_rnd]++;
        userData[TBW_position_column] = ((userData[TBW_rnd] & 0x0010)>0) + ((userData[TBW_rnd] & 0x0008)>0);
      }else{
        if(userData[TBW_position_row] < (env->rows-1))      
          if(LEDmap[BC(env->columns * (userData[TBW_position_row]+1) + userData[TBW_position_column], BLUE)] > 0){
            LEDmap[BC(env->columns * userData[TBW_position_row] + userData[TBW_position_column], BLUE)] = userData[TBW_cubecolor];
            if(userData[TBW_position_row] == 0) env->gameFinished = 1;
            userData[TBW_position_row] = 0;
            userData[TBW_rnd]++;
            userData[TBW_position_column] = ((userData[TBW_rnd] & 0x0001)>0) + ((userData[TBW_rnd] & 0x0002)>0);
          }else
            userData[TBW_position_row] += 1;
      }
    }
    
    for(userData[TBW_i] = 0; userData[TBW_i] < env->rows; userData[TBW_i]++)
      for(userData[TBW_y] = 0; userData[TBW_y] < env->columns; userData[TBW_y]++){
        if(LEDmap[BC(env->columns * userData[TBW_i] + userData[TBW_y], BLUE)] == 0)
          break;
        if(userData[TBW_y] == (env->columns-1)){
          if(userData[TBW_level]    ) userData[TBW_level]--;
          if(userData[TBW_level]> 80) userData[TBW_level] -= 3;
          if(userData[TBW_level]>160) userData[TBW_level] -= 10;
          if(userData[TBW_level]>300) userData[TBW_level] -= 20;
          for(userData[TBW_ii] = (userData[TBW_i]-1); userData[TBW_ii] >= 0; userData[TBW_ii]--)
            for(userData[TBW_yy] = 0; userData[TBW_yy] < env->columns; userData[TBW_yy]++){
              LEDmap[BC(env->columns * (userData[TBW_ii]+1) + userData[TBW_yy], BLUE)] = LEDmap[BC(env->columns * userData[TBW_ii] + userData[TBW_yy], BLUE)];
            }
        }
      }

    LEDmap[BC(env->columns * userData[TBW_position_row] + userData[TBW_position_column], GREEN)] = userData[TBW_cubecolor];  //draw new cube
    if(env->gameFinished){
      for(userData[TBW_y] = 0; userData[TBW_y] < env->columns; userData[TBW_y]++){
        tmpenv = env->columns * userData[TBW_position_row] + userData[TBW_y];
				LEDmap[BC(tmpenv, RED)] = userData[TBW_cubecolor];      
        LEDmap[BC(tmpenv, GREEN)] = 0;      
        LEDmap[BC(tmpenv, BLUE)] = 0;      
      }
    }
    env->refreshRequest = 1;
  }
  btnADC->buttonCenter  = 0;
  userData[TBW_counter] ++;
}
//====================================================================================================================

//---------------------------------------------------------- one_Color ------------------------------------------
void solid_color_demo(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData){
#define OC_notUsed 0
#define OC_i 1
#define OC_y 2
#define OC_select 3
#define OC_bright 4
  
  //-------------------- demo setup --------------------------
  if(env->setupGame){               
    env->setupGame = 0; 
    env->gameFinished = 0;
    userData[OC_select] = 1;
    env->refreshRequest = 1;
  }
  if(btnADC->buttonRight)  { btnADC->buttonRight = 0; userData[OC_select]++; if(userData[OC_select] > 7) userData[OC_select] = 0;}
  if(btnADC->buttonLeft)   {  btnADC->buttonLeft = 0; userData[OC_select]--; if(userData[OC_select] < 0)  userData[OC_select] = 7;}
  userData[OC_bright] = btnADC->buttonKnob();
  if(userData[OC_bright] < minimalBrightness) userData[OC_bright] = minimalBrightness;
  
  userData[OC_y] = -1;
  for(userData[OC_i] = 0; userData[OC_i] < env->rows; userData[OC_i]++){
    for(; userData[OC_y] < env->columns; userData[OC_y]++){
			tmpenv = env->columns * userData[OC_i] + userData[OC_y];
      switch(userData[OC_select]){
      case 0:LEDmap[BC(tmpenv, BLUE)] =  0x00;
             LEDmap[BC(tmpenv, RED)] =   0x00;
             LEDmap[BC(tmpenv, GREEN)] = 0x00;
             break;
      case 1:LEDmap[BC(tmpenv, BLUE)] =  0x00;
             LEDmap[BC(tmpenv, RED)] =   userData[OC_bright];
             LEDmap[BC(tmpenv, GREEN)] = 0x00;
             break;
      case 2:LEDmap[BC(tmpenv, BLUE)] =  0x00;
             LEDmap[BC(tmpenv, RED)] =   0x00;
             LEDmap[BC(tmpenv, GREEN)] = userData[OC_bright];
             break;
      case 3:LEDmap[BC(tmpenv, BLUE)] =  userData[OC_bright];
             LEDmap[BC(tmpenv, RED)] =   0x00;
             LEDmap[BC(tmpenv, GREEN)] = 0x00;
             break;
      case 4:LEDmap[BC(tmpenv, BLUE)] =  0x00;
             LEDmap[BC(tmpenv, RED)] =   userData[OC_bright];
             LEDmap[BC(tmpenv, GREEN)] = userData[OC_bright];
             break;
      case 5:LEDmap[BC(tmpenv, BLUE)] =  userData[OC_bright];
             LEDmap[BC(tmpenv, RED)] =   0x00;
             LEDmap[BC(tmpenv, GREEN)] = userData[OC_bright];
             break;
      case 6:LEDmap[BC(tmpenv, BLUE)] =  userData[OC_bright];
             LEDmap[BC(tmpenv, RED)] =   userData[OC_bright];
             LEDmap[BC(tmpenv, GREEN)] = 0x00;
             break;
      case 7:LEDmap[BC(tmpenv, BLUE)] =  userData[OC_bright];
             LEDmap[BC(tmpenv, RED)] =   userData[OC_bright];
             LEDmap[BC(tmpenv, GREEN)] = userData[OC_bright];
             break;
      }
			}
    userData[OC_y] = 0;
  }
  env->refreshRequest = 1;
}
//====================================================================================================================

//---------------------------------------------------------- error_demo ------------------------------------------
void error_demo(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData){
  #define ED_counter 0
//  #define ED_data1 0
//  #define ED_data2 1
//  #define ED_data3 2
  #define ED_i 3
  #define ED_y 4
  #define ED_bright 5
    
  if(env->setupGame){               
    env->setupGame = 0; 
    env->gameFinished = 0;
    userData[ED_counter] = 0;
  }
  
  if(userData[ED_counter] == 5){
    userData[ED_bright] = btnADC->buttonKnob();
    if(userData[ED_bright] < minimalBrightness) userData[ED_bright] = minimalBrightness;
    for(userData[ED_i] = 0; userData[ED_i] < env->rows; userData[ED_i]++)
      for(userData[ED_y] = 0; userData[ED_y] < env->columns; userData[ED_y]++){
        tmpenv = env->columns * userData[ED_i] + userData[ED_y];
        if((LEDmap[BC(tmpenv, GREEN)] == 0) ||
           (LEDmap[BC(tmpenv,  BLUE)] == 0) ||      
           (LEDmap[BC(tmpenv,   RED)] == 0)    )
           {
           LEDmap[BC(tmpenv, RED)] = userData[ED_bright];
           LEDmap[BC(tmpenv, GREEN)] = 0x00;
           LEDmap[BC(tmpenv, BLUE)] = 0x00;
           }
        else{
           LEDmap[BC(tmpenv, RED)] = 0x00;
           LEDmap[BC(tmpenv, GREEN)] = 0x00;
           LEDmap[BC(tmpenv, BLUE)] = 0x00;
        }
      }
    env->refreshRequest = 1;

    if((LEDmap[BC(-1, GREEN)] == 0) ||
       (LEDmap[BC(-1,  BLUE)] == 0) ||      
       (LEDmap[BC(-1,   RED)] == 0)    )
       {
         LEDmap[BC(-1, RED)] = userData[ED_bright];
         LEDmap[BC(-1, GREEN)] = 0x00;
         LEDmap[BC(-1, BLUE)] = 0x00;
       }
       else{
         LEDmap[BC(-1, RED)] = 0x00;
         LEDmap[BC(-1, GREEN)] = 0x00;
         LEDmap[BC(-1, BLUE)] = 0x00;
       }
  }
  if(userData[ED_counter] == 30000)   //500000
    env->gameFinished = 1;
  
  if(userData[ED_counter] > 30000){   //500000
    userData[ED_counter] = 0;
    env->gameFinished = 0;
  }
  userData[ED_counter] ++;
}

//====================================================================================================================

void writeCharacter(unsigned char *LEDmap, unsigned char *mask, unsigned short brightnessR, unsigned short brightnessG, unsigned short brightnessB, unsigned char Rotate){
  if(Rotate)
    for(i=0 ; i < 15; i++){
      LEDmap[BC(14-mask[i], RED)] = brightnessR;
      LEDmap[BC(14-mask[i], GREEN)] = brightnessG;
      LEDmap[BC(14-mask[i], BLUE)] = brightnessB;
    }else
    for(i=0 ; i < 15; i++){
      LEDmap[BC(mask[i], RED)] = brightnessR;
      LEDmap[BC(mask[i], GREEN)] = brightnessG;
      LEDmap[BC(mask[i], BLUE)] = brightnessB;
    }
}

//---------------- character map, dedicated to a certain demoboard ---------------------------------
const unsigned char number_mask[11][15] = 
{{ 1, 3, 5, 6, 8,       9,11,13, 1, 1,        1, 1, 1, 1, 1},   // 0
 { 1, 3, 4, 7,10,      12,13,14, 1, 1,        1, 1, 1, 1, 1},   // 1
 { 3, 1, 5, 8,10,      12,13,14, 1, 1,        1, 1, 1, 1, 1},   // 2
 { 0, 1, 5, 7, 0,      11,12,13, 1, 1,        1, 1, 1, 1, 1},   // 3
 { 1, 3, 4, 6, 7,       8,10,13, 1, 1,        1, 1, 1, 1, 1},   // 4
 { 0, 1, 2, 3, 6,       7, 8,11,12,13,        1, 1, 1, 1, 1},   // 5
 { 1, 3, 6, 7, 8,       9,11,13, 1, 1,        1, 1, 1, 1, 1},   // 6
 { 0, 1, 2, 5, 8,      10,12, 1, 1, 1,        1, 1, 1, 1, 1},   // 7
 { 1, 3, 5, 7, 9,      11,13, 1, 1, 1,        1, 1, 1, 1, 1},   // 8
 { 1, 3, 5, 6, 7,       8,11,13, 1, 1,        1, 1, 1, 1, 1},   // 9
 { 1, 2, 3, 4, 5,       6, 7, 8, 9,10,       11,12,13,14,15}};   // ALL

const unsigned char character_mask[31][15] = 
{{13, 9,11, 6, 7,       3, 5, 8, 2, 0,        0, 0, 0, 0, 0},   // A - 0
 { 1, 2, 3, 5, 1,       7, 8, 9,11,13,       14, 1, 1, 1, 1},   // B - 1
 { 0, 1, 5, 8,11,      13,12, 1, 1, 1,        1, 1, 1, 1, 1},   // C - 2
 { 1, 2, 3, 5, 6,       8, 9,11,13,14,        1, 1, 1, 1, 1},   // D - 3
 { 0, 1, 2, 5,11,       7, 8,12,13,14,        1, 1, 1, 1, 1},   // E - 4
 { 5, 5, 2, 5,11,       7, 8,12,13,14,        5, 5, 5, 5, 5},   // F - 5
 { 3, 1, 5, 8,11,      13,12, 4, 6, 7,        0, 1, 1, 1, 1},   // G - 6
 { 0, 3, 6, 9,12,       2, 5, 8,11,14,        7, 7, 7, 7, 7},   // H - 7
 { 1, 4, 7,10,13,       1, 1, 1, 1, 1,        1, 1, 1, 1, 1},   // I - 8
 { 1, 3, 6, 9,12,       5, 1, 1, 1, 1,        1, 1, 1, 1, 1},   // J - 9
 { 2, 5, 8,11,14,       7, 9, 0,12, 3,        0, 0, 0, 0, 0},   // K - 10
 { 2, 5, 8,11,14,       0, 1, 1, 1, 1,        1, 1, 1, 1, 1},   // L - 11
 { 0, 3, 6, 9,12,       2, 5, 8,11,14,       10,10,10,10,10},   // M - 12
 { 0, 3, 6, 9,12,       2, 5, 8,11,14,       10, 7, 4,10,10},   // N - 13
 { 5, 8,11, 1,13,       3, 6, 9, 1, 1,        1, 1, 1, 1, 1},   // O - 14
 {14,11, 8, 5, 2,      13, 7, 9, 2, 2,        2, 2, 2, 2, 2},   // P - 15
 { 5, 8,11, 1,13,       3, 6, 9, 4, 0,        1, 1, 1, 1, 1},   // Q - 16
 {14,11, 8, 5, 2,      13, 7, 9, 3, 0,        2, 2, 2, 2, 2},   // R - 17
 { 1, 2, 3, 7,11,      13,12, 1, 1, 1,        1, 1, 1, 1, 1},   // S - 18
 { 1, 4, 7,10,13,      12,14, 1, 1, 1,        1, 1, 1, 1, 1},   // T - 19
 {14,11, 8, 5, 1,       3, 6, 9,12, 0,        1, 1, 1, 1, 1},   // U - 20
 {14,11, 8, 5, 1,       3, 6, 9,12, 1,        1, 1, 1, 1, 1},   // V - 20
 { 0, 3, 6, 9,12,       2, 5, 8,11,14,        4, 4, 4, 4, 4},   // W - 21
 {14,12,11, 9, 7,       5, 3, 2, 0, 0,        0, 0, 0, 0, 0},   // X - 22
 { 1, 4, 7,11,14,       9,12, 1, 1, 1,        1, 1, 1, 1, 1},   // Y - 23
 {14,13,12, 9, 7,       5, 2, 1, 0, 1,        1, 1, 1, 1, 1},   // Z - 24
 { 4,10, 4, 4, 4,       4, 4, 4, 4, 4,        4, 4, 4, 4, 4},   // : - 25
 { 1, 1, 1, 1, 1,       1, 1, 1, 1, 1,        1, 1, 1, 1, 1},   // . - 26 (92)
 { 1, 3, 6, 9,13,       1, 1, 1, 1, 1,        1, 1, 1, 1, 1},   // ) - 27 (93)
 {12,10, 7, 4, 0,       0, 0, 0, 0, 0,        0, 0, 0, 0, 0},   // ( - 28 (94)
{  1, 2, 3, 4, 5,       6, 7, 8, 9,10,       11,12,13,14, 0}};  //ALL - 29 (95)

