/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : led_demonstration.h
* Author             : EMMA team Prague
* Date First Issued  : 30/01/2008
* Description        : 
********************************************************************************
* History:
* 30/01/2008: V0.0
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __LED_DEMONSTRATION_H
#define __LED_DEMONSTRATION_H

#include "board_control.h"

#define BLUE 1
#define RED 2
#define GREEN 3
#define DONOTROTATE 0
#define ROTATE 1

extern const unsigned char number_mask[11][15];
extern const unsigned char character_mask[31][15];
//extern const unsigned char sinuslog[101];

struct environment
{
  unsigned char columns;            //size of display
  unsigned char rows;               //size of display
  unsigned char colors;             //1 - one color, 3 RGB leds.
  unsigned char randomNumber;       //some games need random number
  unsigned char gameFinished;       //when game ends
  unsigned char setupGame;          //set flag when started first. The flag is cleared automaticaly
  unsigned char refreshRequest;     //game changed data to display
};

void modeSelect(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData);

void tetris_color(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData);

void solid_color_demo(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData);

void wave_color_demo(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData);

void error_demo(unsigned char *LEDmap, struct buttonsAndADC *btnADC, struct environment *env, signed int *userData);

void writeCharacter(unsigned char *LEDmap, unsigned char *mask, unsigned short brightnessR, unsigned short brightnessG, unsigned short brightnessB, unsigned char Rotate);

/*******************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

#endif
