/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : main.c
* Author             : Emma connectivity Prague
* Date First Issued  : 12/xx/2007
* Description        : Main program body
********************************************************************************
* History:
* mm/dd/yyyy: V0.1
* 12/00/2007: V0.01
********************************************************************************
* THE PRESENT SOFTWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH SOFTWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

extern unsigned char _endmem @0x17ff;

#include "stm8s_lib.h"

#include "led_dimmer.h"
#include "table_generator.h"
#include "led_demonstration.h"
#include "board_control.h"

extern struct buttonsAndADC buttonsADC;
//unsigned char *LookUp;

unsigned char LEDmapClear[48] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                            
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,                            
                                 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
int tableSize;
unsigned char *tablePtr, *tableKeyPtr;
unsigned char modeSelector;

//demonstration
struct environment env;
struct buttonsAndADC buttons;
signed int userData[12];
//end of demonstration

int X;

void waitAbit(int a){
  unsigned int i, y;
  for(i=0; i<600; i++)  
    for(y=0; y<a; y++)
      X = a+i+y;
}

int main(void){
#ifdef DEBUG
  debug();
#endif

  RCC_Configuration();
  NVIC_Configuration();
  SPI_GPIO_Init();

  fillDriver(48);
  LED_driver_OutEnable_All_On();
  GPIO_WriteLow( LE_PORT, LE_PIN); //FAST_LE_LOW();
  GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();

  setup(48, PWM_8_bit, 100);

  if(!generateReducedLookUpTable(LEDmapClear, 48, PWM_8_bit, &tablePtr, &tableKeyPtr, &tableSize))
    while(1);
  use_new_table_immediately(tablePtr, tableKeyPtr, tableSize);

  start_dimmer();
 
  BC_GPIO_Configuration();
  BC_EXTI_Configuration();
  BC_ADC_Configuration();

  LED_driver_OutEnable_All_On();
  
  #define modes 4+1;
  modeSelector = 100;
  userData[1] = modes;
  env.columns = 3;
  env.rows = 5;
  env.setupGame = 1;      
  
  while(1){

    switch(modeSelector){

    case   0: tetris_color(LEDmapClear, &buttonsADC, &env, &(userData[0]));break;   //A - tetris
    case   1: wave_color_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));break;  //B - WAVE demo
    case   2: solid_color_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));break; //C - solid color demo
    case   3: error_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));             //D - error detection
              if(env.gameFinished){
                error_detection_DMX(LEDmapClear, 48);
                start_dimmer();
                LED_driver_OutEnable_All_On();
              }
              break;
    case   4: error_demo(LEDmapClear, &buttonsADC, &env, &(userData[0]));         //E - error detection
              if(env.gameFinished){
                error_detection_LE_OE(LEDmapClear, 48);
                start_dimmer();
                LED_driver_OutEnable_All_On();
              }
              break;
    case 100: modeSelect(LEDmapClear, &buttonsADC, &env, &(userData[0]));
              if(env.gameFinished){
                env.setupGame = 1;
                env.gameFinished = 0;
                modeSelector = userData[0];
                break;
                }
    default:modeSelector = 100;break;
    }

    if(env.refreshRequest){
      if(!generateReducedLookUpTable(LEDmapClear, 48, PWM_8_bit, &tablePtr, &tableKeyPtr, &tableSize))
        while(1);
      use_new_table_carefully(tablePtr, tableKeyPtr, tableSize);
      while(new_table_not_changed_yet());
      removeLookUpTableReleased();
      env.refreshRequest = 0;
    }
  }  
}//main
