
#include "table_generator.h"
#include <stdlib.h>
//#include "stm32f10x_lib.h"

//unsigned char tmptmp[40];
//int iii;

unsigned int DATAchar, outputBIT, tmpdepth;

void sort(unsigned char *a, int size){
  int i,y;
  unsigned char tmp;
    for(i=0; i<size; i++)
      for(y=i; y<size; y++)
        if(a[i] > a[y]){
          tmp  = a[i];
          a[i] = a[y];
          a[y] = tmp;
        }
}

int differentValuesCount(unsigned char *a, int size){
  int i, y, count;
  count = 1;               //we automaticaly include zero
  for(i = 1; i < 255; i++) //we have already included zero
    for(y = 0; y < size; y++)
      if(a[y] == i){
        count++;
        break;
      }
  return count;
}

unsigned char *SortAndReduce(unsigned char *a, int size, int reducedSize){
  int i, y, count;
  unsigned char *reduced;
  count = 1;   //we automaticaly include zero
  reduced = NULL;
  reduced = malloc(reducedSize);
  if(!reduced)
    return NULL;
  reduced[count-1] = 0;
  for(i = 1; i < 255; i++)  //we do not want 0xFF but always 0x00
    for(y = 0; y < size; y++)
      if(a[y] == i){
        reduced[count] = i;
        count++;
        break;
      }
  return reduced;
}

int reduce(unsigned char *a, int size){
  int newsize, i, y;
  for(i = 0; i<size; i++)
    for(y = i; y<size; y++)
      if(a[y] > a[i]){
        a[i+1] = a[y];
        newsize = i+1;
        break;
      }
  return newsize;
}

unsigned char *generateFullLookUpTable(unsigned char *LEDmapIN, int LEDcount, int PWMdepth){
  unsigned char* LookUpPtr;
  int streamSize = LEDcount/8;
  LookUpPtr = malloc(streamSize * PWMdepth);
  for(tmpdepth = 0; tmpdepth < PWMdepth; tmpdepth++){
    for(DATAchar = 0; DATAchar < streamSize; DATAchar++){
      for(outputBIT = 0; outputBIT < 8; outputBIT++){
        LookUpPtr[tmpdepth*streamSize + DATAchar] <<= 1;
        if(LEDmapIN[(DATAchar*8) + outputBIT] > tmpdepth)
          LookUpPtr[tmpdepth*streamSize + DATAchar] |= 0x01;
        else
          LookUpPtr[tmpdepth*streamSize + DATAchar] &= 0xFE;
      }
    }
  }

  return LookUpPtr;
}

int performGenerateReducedLookUpTable(unsigned char *LEDmapIN, int LEDcount, int PWMdepth, unsigned char **tableIN, unsigned char **tableKeyIN, int *table_size){
  int streamSize = LEDcount/8;

  //tableKeyINa = malloc(1 * sizeof(unsigned char *));
  
  *table_size = differentValuesCount(LEDmapIN, LEDcount);
  *tableKeyIN = SortAndReduce(LEDmapIN, LEDcount, *table_size);

  *tableIN = malloc(streamSize * (*table_size) * sizeof(unsigned char));
  for(tmpdepth = 0; tmpdepth < (*table_size); tmpdepth++){
    for(DATAchar = 0; DATAchar < streamSize; DATAchar++){
      for(outputBIT = 0; outputBIT < 8; outputBIT++){
        (*tableIN)[tmpdepth*streamSize + DATAchar] <<= 1;
        if(LEDmapIN[(DATAchar*8) + outputBIT] > (*tableKeyIN)[tmpdepth])
          (*tableIN)[tmpdepth*streamSize + DATAchar] |= 0x01;
        else
          (*tableIN)[tmpdepth*streamSize + DATAchar] &= 0xFE;
      }
    }
  }

  if((*tableIN)&&(*tableKeyIN))
    return SUCCESS;
  else
    return ERROR;
}

/*
int eventsToTimes(unsigned char **tableKeyIN, int *table_size){
  int i;
  for(i = 0; i < (*table_size); i++)
    (*tableKeyIN)[i] = 0;
  return 0;
}
*/